#!/bin/sh

#
# If we have a configfile in pwd, use it, otherwise use the system-wide config file
#
CONFIGNAME=coredata-dbus.conf
if [ -f ./${CONFIGNAME} ]
then
    CONFIGFILE=./${CONFIGNAME}
else
    CONFIGFILE=/6100/etc/${CONFIGNAME}
fi

PIDFILE=/6100/var/run/coredata-dbus.pid

stop()
{
    if [ -f ${PIDFILE} ]
    then 
        echo -n "Stopping coredata dbus daemon... "
        kill `cat ${PIDFILE}` 2>&1 >/dev/null && rm -f ${PIDFILE}
        echo  done
    fi
}

start()
{
    echo -n "Starting core dbus daemon... "
    /usr/bin/dbus-daemon --config-file=${CONFIGFILE} --print-pid 3 3> ${PIDFILE}
    echo "done"
}

case "$1" in
    'init')
        start
        ;;
    'start'|'restart')
        stop
        start
        ;;
    'stop')
        stop
        ;;
    *)
        echo "usage: coredata-dbus.sh start|restart|stop"
        echo "References \$cwd/coredata-dbus.conf or else /6100/etc/coredata-dbus.conf"
        ;;
esac
