#!/bin/sh

# FILE: find_datum.sh
# COPYRIGHT: 2011 FORCE America, Inc
# DESCRIPTION: Given a search pattern, finds all datums that meet that
#              pattern in config.db
#              Output is of format name:type, which can be used as
#              input to the observe program to watch these datums
#              on the CoreData DBus.
#              Note:  pattern_to_match is a pattern that follows the glob
#                     format.  See the glob(7) manpage for the syntax (man 7 glob).
# CREATED:     4/14/2011 By Jon Polfer (P1131)
# USAGE:       find_datum.sh <pattern_to_match>

echo "SELECT id||':'||type FROM sysvar WHERE id GLOB '$1';" | 
    sqlite3 /6100/etc/config.db
