#! /bin/bash

if [ "${1}" = "info" ]
then
echo -e "\e[7m\t* move_Ex.sh is a helper function for transferring files from a drive in the port to the system in need.\n
\t* Input info with the executable will print these instructions\n
\t* Input './move_Ex' will opt for a menu of possible items to move\n
\t* Input './move_Ex 1' will opt for user input naming which will be checked for existence prior to transporting \n
\t* Input 'q' or 'Q' at anytime will exit the script\n
\t* Input of r will reboot the system once an executable has been identified\n\e[0m"

else
q=1
echo -n $(mount /dev/sda1 /media/disk)
while [ "$q" = '1' ] ; do
flag=1;
	if [ ! "${1}" = '1' ] 
	then
		
		printf "Select the number of the executable that needs to be moved or press q to quit\n
			  \t(1) CanManager\n
			  \t(2) gui\n
                          \t(3) SerialManager\n
                          \t(4) CameraManager\n
                          \t(5) CanSimulator\n
                          \t(6) SimulatorGui\n
                          \t(7) config.db\n
                          \t(8) Default.config\n
                          \t(9) simulator.db\n
                        "
		
				#get user input until either quit or a valid input is received
				while [ "$flag" = 1 ]; 
						do
                                                simulator=0
				read ex_num

					if [ "$ex_num" = "q" ] || [ "$ex_num" = "Q" ]
					   then
					   	#quitting out
						flag=0
						q=0
					elif [[ "$ex_num" > 8 || "$ex_num" < 1 ]];
						then
						#invalid input (try again)
						echo -e "\e[7mThe executable number entered is not in the list, try again or press 'q' to quit \e[27m "
					
					else
						#valid input
						if   [ $ex_num -eq 1 ]; then
                                                        executable="CanManager"
                                                        dir="bin"
						elif [ $ex_num -eq 2 ]; then
							executable="gui"
                                                        dir="bin"
						elif [ $ex_num -eq 3 ]; then
                                                        executable="SerialManager"
                                                        dir="bin"
						elif [ $ex_num -eq 4 ]; then
                                                        executable="CameraManager"
                                                        dir="bin"
                                                elif [ $ex_num -eq 5 ]; then
                                                        executable="CanSimulator"
                                                        dir="bin"
                                                        simulatorb=1
                                                        simulator="CanManager"
                                                elif [ $ex_num -eq 6 ]; then
                                                        executable="SimulatorGui"
                                                        dir="bin"
                                                        simulatorb=1
                                                        simulator="gui"
                                                elif [ $ex_num -eq 7 ]; then
                                                        executable="config.db"
                                                        dir="etc"
                                                elif [ $ex_num -eq 8 ]; then
                                                        executable="Default.config"
                                                        dir="etc"
                                                elif [ $ex_num -eq 9 ]; then
                                                        executable="simulator.db"
                                                        dir="etc"
                                                        simulator="config.db"
                                                        simulatorb=1
						fi
					#exit the while loop because either the user wants to quit or there has been a valid input
						if [ ! -f "/media/disk/$executable" ];
						   then
						   	#invalid input
							echo -e "\e[7mThe executable entered was not found, replug-in the drive \e[27m "
							#quitting out because the drive did not connect
							flag=0;
						fi
					flag=0;
					fi
				done
	else 
		
                echo "Enter the executable that needs to be moved to /bin or press q to quit"

		while [ "$flag" = 1 ]; 
				do
				
		read executable
		#find / -name "$executable"
			if [ "$executable" = "q" ] || [ "$executable" = "Q" ];
			   then
			   	#quitting
				flag=0
				q=0
			#checking file existence
			elif [ ! -f "/media/disk/$executable" ];
			   then
			   	#invalid input
				echo -e "\e[7mThe executable entered was not found, try again or press 'q' to quit. Start script with argument info for help \e[27m "
				
			else
				#valid input
				flag=0
				
			fi
		done
	fi
	#if the user quit out (q = 0) then skip reboot and moving files
	if [ "$q" = 1 ]; 
		then
		echo "Input 'r' for reboot, otherwise press enter"
		read input
		#give user notice of processing in case large files take awhile
		echo "Moving file..."
                if [ "$simulatorb" = 1 ];
                    then
                    echo -n $(cp /media/disk/"$executable" /6100/"$dir"/"$simulator")
                else
                    echo -n $(cp /media/disk/"$executable" /6100/"$dir")
                fi
		#reboot system
		if [ "$input" = "r" ]; 
			then
			#unmounting in case of reboot
			echo -n $(umount /media/disk)
			q=0
			echo -e "\e[32mFinished moving desired file: $executable. Rebooting now...\e[0m"
			reboot
		else
			echo -e "\e[32mFinished moving desired file: $executable.\e[0m"
		fi

	else
		echo "Quitting out"
		
	fi
done
if [ ! "$input" = "r" ];
	then
	echo -n $(umount /media/disk)
fi
fi

