#!/bin/sh
#  rev11torev12dbupgrade.sh
#  (c) 2020 FORCE America, Inc
#  Upgrades a rev11 database to a rev12 database.
#  $1 - path to database to upgrade

################################################################################
# Returns whether/not a variable contains an integer.
# $1 - variable to check
################################################################################
function is_integer
{
    if [[ $(echo $1 | grep -E "^[0-9]+$") ]]; then
        return 0;
    else
        return 1;
    fi
}

################################################################################
# Main thread of execution
################################################################################

# Step 1: Check that database is the proper rev.
DbRevision=`echo "SELECT snapshot_schema_version FROM meta;" | sqlite3 $1`;
is_integer $DbRevision;
IsIntegerResult=$?;
if [[ $IsIntegerResult -eq 0 ]]; then
    if [[ "$DbRevision" -ne 11 ]]; then
        logger "UpgradeRev11ToRev12.sh: Database is Rev $DbRevision, Skipping..."
        exit 0;
    fi
fi

# Step 2: Back up current database
cp $1 $1.old;

# Step 6: Copy data from the backup database
sqlite3 $1 < UpgradeRev11ToRev12.sql

logger "UpgradeRev11ToRev12.sh: Database upgraded to Rev 12."
